'use strict';
//Modules
var React = require('react');
var $ = require('jquery');
var is = require('is_js');
//Components


/**
 * Scale-font
 *
 *
 * @prop
 */
var FontScale = React.createClass({
  /**
   * Prop Types
   */
  propTypes: {
    children: React.PropTypes.array,
    minWidth: React.PropTypes.number,
    maxWidth: React.PropTypes.number,
    minFontSize: React.PropTypes.number,
    maxFontSize: React.PropTypes.number,
    // disable: React.PropTypes.boolen
  },

  getInitialState:function () {
    return({
      windowHeight: 0,
      windowWidth: 0

    })
  },

  getWindowDimensions:function () {
    this.setState({
      windowWidth: Math.max(document.documentElement.clientWidth, window.innerWidth || 0),
      windowHeight: Math.max(document.documentElement.clientHeight, window.innerHeight || 0)
    });
  },

  componentDidMount:function () {
    window.addEventListener("resize", this.getWindowDimensions);
    this.getWindowDimensions();
  },

  /**
   * [fontSizeScale description]
   * @param  {object} props [description]
   * @return {string} font size number /string number plus + 'px'
   *
   */
  fontSizeScale:function (windowWidth) {
    var minWidth = is.propertyDefined(this.props, 'minWidth')  ? this.props.minWidth : 300,
        maxWidth = is.propertyDefined(this.props, 'maxWidth')  ? this.props.maxWidth : 600,
        minFontSize = is.propertyDefined(this.props, 'minFontSize')  ? this.props.minFontSize : 10, //font size @ 300 width
        maxFontSize = is.propertyDefined(this.props, 'maxFontSize')  ? this.props.maxFontSize : 20, //font size @ 640 width
        fontSize,
        percentage;

    // Dont go beyond max and min width
    if( windowWidth >= minWidth && windowWidth <= maxWidth ){
      percentage = ( windowWidth - (maxWidth-minWidth) ) / (maxWidth - minWidth)
      fontSize = minFontSize + ((maxFontSize-minFontSize)*percentage)
    } else if(windowWidth <= maxWidth) {
      fontSize = minFontSize;
    } else {
      fontSize = maxFontSize;
    }

    return ( !this.props.disable ? fontSize + 'px' : null);
  },

  /**
   * Render
   * @return {[type]} [description]
   */
  render: function() {

    return (
      <div className='font-scale' style={{fontSize: this.fontSizeScale(this.state.windowWidth) }}>
          {this.props.children}
      </div>
    );
  }

});

module.exports = FontScale;
